#include	<stdlib.h>
#include	<stdio.h>
#include	<dos.h>
#include	<string.h>

#include	"read.h"

void main(int argc,char **argv)
{
	unsigned	char	szRegs[25];
	char	szOut[256];
	char	szWork[256];
	int	n,bSetMode;
	unsigned char	nmode,oldmode;
	FILE	*f;

	oldmode=*(unsigned char far *)MK_FP(0x40,0x49);


	bSetMode=0;

	for(n=0;n<argc;n++)
	{
		if(!strcmpi(argv[n],"/h")||!strcmpi(argv[n],"-h")||
				!strcmpi(argv[n],"/?")||!strcmpi(argv[n],"-?"))
		{
			printf("\nVGAREAD\n");
			printf("\nReads in VGA Timing registers and outputs them to 2 files\n");
			printf("syntax:\n");
			printf("VGAREAD - registers for current mode\n");
			printf("VGAREAD <n> - registers for mode <n>\n\n");
			printf("Files Created:\n");
			printf("vgaregs<n>.txt (where <n> is the VGA mode)\n");
			printf(" text output of timing registers\n\n");
			printf("vgaregs<n>.reg (where <n> is the VGA mode)\n");
			printf(" binary output of just the register values\n");
			printf("\nNOTE:Certain modes are reserved or old and will not be set\n");
			printf("these are - modes 6 to 12\n");

			return;
		}
	}
	if(argc>=2)
	{
		bSetMode=1;
		nmode=atoi(argv[1]);
		if(!nmode&&argv[1][0]!='0')
			bSetMode=0;
	}
	if(bSetMode)
	{
		if(nmode>0x13)
		{
			printf("Non VGA mode requested\n");
			return;
		}
		if(nmode>5&&nmode<13)
		{
			printf("old or reserved mode (%d)\n",(int)nmode);
			return;
		}
		setgmode(nmode);
	}
	else
		nmode=oldmode;

	printf("\nMode : %d (%xh)\n",nmode,nmode);
	memset(szRegs,0,25);
	readregs(szRegs);
	sprintf(szOut,"vgareg%d.reg",nmode);
	f=fopen(szOut,"wb");
	if(f)
	{
		fwrite(szRegs,1,25,f);
		fclose(f);
	}
	sprintf(szOut,"vgareg%d.txt",nmode);
	f=fopen(szOut,"wt");
	if(f)
	{
		sprintf(szWork,"vgaregs%d:\n",nmode);
		fputs(szWork,f);
		fputs(";3c2\n",f);
		sprintf(szWork,"db\t%d\n",(int)szRegs[0]);
		fputs(szWork,f);
		fputs(";3d4 0 - 9\n",f);
		strcpy(szOut,"db\t");
		for(n=0;n<10;n++)
		{
			sprintf(szWork,"%d,",(int)szRegs[n+1]);
			strcat(szOut,szWork);
		}
		szOut[strlen(szOut)-1]=0;
		strcat(szOut,"\n");
		fputs(szOut,f);
		fputs(";3d4 10h - 17h\n",f);
		strcpy(szOut,"db\t");
		for(n=0;n<8;n++)
		{
			sprintf(szWork,"%d,",(int)szRegs[n+11]);
			strcat(szOut,szWork);
		}
		szOut[strlen(szOut)-1]=0;
		strcat(szOut,"\n");
		fputs(szOut,f);
		fputs(";3c4 1,4\n",f);
		sprintf(szOut,"db %d,%d\n",(int)szRegs[19],(int)szRegs[20]);
		fputs(szOut,f);

		fputs(";3ce 5,6\n",f);
		sprintf(szOut,"db\t%d,%d\n",(int)szRegs[21],(int)szRegs[22]);
		fputs(szOut,f);
		fputs(";3c0 10h,13h\n",f);
		sprintf(szOut,"db\t%d,%d\n",(int)szRegs[23],(int)szRegs[24]);
		fputs(szOut,f);
		fclose(f);
	}
	if(oldmode!=nmode)
		setgmode(oldmode);

}
