; VGAASM.ASM
; Assembler functions for VGA
; and 8042 stuff

.MODEL  medium
.CODE


PUBLIC  	_setmagicmode,_repbios,_newbios,_putbios
PUBLIC   _initbios,_setarcade,_setcabinet



MCRTC	MACRO
	mov	ah,bl
	lodsb
	xchg	al,ah
	out	dx,ax
	inc	bl
	ENDM

MGEN	MACRO
	mov	ah,bl
	lodsb
	xchg	al,ah
	out	dx,ax
	ENDM

MATTR	MACRO
	mov	dx,3dah
	in		al,dx
	mov	dx,3c0h
	mov	al,bl
	or		al,32
	out	dx,al
	lodsb
	out	dx,al
	ENDM


INTTAB2  SEGMENT AT 0H
	ORG	10H*4
BIOSADDR  LABEL   DWORD
INTTAB2  ENDS



_setmagicmode	PROC
	push	bp
	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	push	si

	mov	bp,bp
	jmp	pastdefs
vgaregs:
;3c2
	db		227
;3d4 0 - 9
	db		93,79,79,148,81,21,4,17,0,64
;3d4 10h - 17h
	db		225,164,199,40,64,224,240,163
;3c4 1,4
	db		9,14
;3ce 5,6
	db		64,5
;3c0 10h,13h
	db		65,0

pastdefs:
	mov	ax,cs
	mov	ds,ax
;first things first
;set the the first
;clear the protection on the VGA regs

	mov	dx,3d4h
	mov	al,11h
	out	dx,al
	inc	dx
	in		al,dx
	and	al,127
	mov	ah,al
	dec	dx
	mov	al,11h
	out	dx,ax


	cld
	mov	dx,offset vgaregs
	mov	si,dx

;3c2 misc. output registers
	lodsb
	mov	dx,3c2h
	out	dx,al
;3d4 the CRTC registers
	mov	dx,3d4h
	mov	cx,10
	xor	bx,bx
crlp1:
	MCRTC
	loop	crlp1

	mov	cx,8
	mov	bl,10h
crlp2:
	MCRTC
	loop	crlp2

;3c4 the sequencer registers
	mov	dx,3c4h
	mov	bl,1
	MGEN
	mov	bl,4
	MGEN

;3ce - graphics controller registers
	mov	dx,3ceh
	mov	bl,5
	MGEN
	mov	bl,6
	MGEN

;3c0 -attribute address registers
	mov	bl,10h
	MATTR
	mov	bl,13h
	MATTR

	pop	si
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	bp
	ret


_setmagicmode	ENDP


_repbios	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds

		jmp     pastd
BIOSSAVE          DD      	?
DOSSAVE				DD			?
KEYBSAVE				DD			?

pastd:
		cli
		assume  ds:INTTAB2
		mov     ax,INTTAB2
		mov     ds,ax
		mov     ax,WORD PTR BIOSADDR
		mov     WORD PTR BIOSSAVE,ax

		mov     ax,WORD PTR BIOSADDR+2
		mov     WORD PTR BIOSSAVE+2,ax

		mov     WORD PTR BIOSADDR,OFFSET _newbios
		mov     WORD PTR BIOSADDR+2,cs


		sti

		pop     ds
		pop     ax
		pop     bp
		ret
_repbios	ENDP



_oldint10h	PROC
	pushf
	call	dword ptr cs:BIOSSAVE
	ret
_oldint10h	ENDP



_newbios	PROC
	jmp	pdata2

varcade	DB	?
vrcallus	DB	?
vkrep		DB ?
vcabinet		DB	?
vtest		DB	?

pdata2:


	push	ax

;see if we're in cabinet
;if we are, ignore all mode sets
;other than 13h
	mov	al,cs:vcabinet
	cmp	al,0
	jne	nocab2
	pop	ax
	cmp	ah,0
	jne	nocab1
	cmp	al,13h
	je		nocab1
	iret
nocab1:
	push	ax
nocab2:


;see if we're setting the magic mode
	mov	al,cs:varcade
	mov	al,cs:vcabinet

	cmp	al,0
	je		noarcade
	pop	ax

;fake 'no SVGA'
	cmp	ah,4fh
	jne	nosvga
	cmp	al,2
	jg		nosvga
	xor	ax,ax
	iret
nosvga:

;check for VGA mode set
	cmp	ah,0
	jne	callold
	cmp	al,13h
	jne	not13h
;set it to our arcade friendly mode
	call	_oldint10h
	call	_setmagicmode
	iret

not13h:
;attempt to set another VGA mode
;which we'll block
not13h:
	iret

callold:
;any old bios call
	call	_oldint10h
	iret

noarcade:
;were not setting arcade mode
;so just call bios normally

	pop	ax
	call	_oldint10h
	iret
_newbios	ENDP


_initbios	PROC
	push	bp
	mov	bp,sp
	push	ax
	xor	al,al
	mov	cs:varcade,al
	mov	cs:vrcallus,al
	mov	cs:vkrep,al
	mov	cs:vcabinet,al
	mov	cs:vtest,al
	pop	ax
	pop	bp
	ret

_initbios	ENDP




_setarcade	PROC
		ARG     	arcval:BYTE

		push   	bp
		mov     	bp,sp
		mov		al,arcval

		mov		cs:varcade,al
		pop		bp
		ret
_setarcade	ENDP

_setcabinet	PROC
		ARG     	cabval:BYTE

		push   	bp
		mov     	bp,sp
		mov		al,cabval

		mov		cs:vcabinet,al
		pop		bp
		ret
_setcabinet	ENDP



_putbios	PROC

	push		bp
	mov		bp,sp
	push  	ds
	push  	ax

	cli
	assume	ds:INTTAB2
	mov     	ax,INTTAB2
	mov     	ds,ax

	mov    	ax,cs:WORD PTR BIOSSAVE
	mov     	ds:WORD PTR BIOSADDR,ax
	mov     	ax,cs:WORD PTR BIOSSAVE+2
	mov    	ds:WORD PTR BIOSADDR+2,ax
	sti

	pop   	ax
	pop     	ds
	pop     	bp
	ret
_putbios	ENDP






		END
